/**************************************************
						   
  konnect4.cpp

  A Connect4 type of game.

  Gihan Marasingha
  1st January 2000


**************************************************/

#include "grid.h"
#include "game.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <ctype.h>

/* nocomms is the number of commands which konnect4
   recognises. commnames holds the names of the commands.
   `flags' gives an integer, one for
   each command, and describes when the command can be
   used. The flag is `ing' if the command can be used
   in a game, the flag is `outg' if the command can
   be used outside of a game, and the flag is `ing+outg'
   if the command can be used at any time
*/


enum {ing=1,outg=2};
char *commnames[] = {"width","height","connect","listen",
  		     "port","score","name","end","quit",
  		     "print","help","rules","bell"};
int flags[] = {outg,outg,outg,outg,outg,ing,outg,ing,
		 ing+outg,ing,ing+outg,ing+outg,ing+outg};
int nocomms = 13; // number of commands.
int match(char *string);
/* if `string' matches a command then match returns the
   number of the command, else it returns -1
*/

int match(char *string)
{
  int i;

  for(i=0;i<nocomms;i++)
    if (!strcmp(string,commnames[i]))
      return i;

  return -1;
}

void getstring(char *input,int length)
{
  char *ptr = input;
  int i = 0;

  do
    {
      *ptr = getchar();
      i++;
    } while ( *ptr++ != '\n' && i<length);
  *(ptr-1) = '\0';
}

int main()
{

  char input[80], *arg;
  int i;
  game mygame;
  
  do
    {
      printf("> ");
      getstring(input,80);
      strtok(input," \t");
      arg = strtok(NULL," \t");
      i = match(input); // find the matching command.

      if(i==-1) // no matches
	{
	  if (isdigit(input[0]) && (mygame.running()==ing))
	    {
	      mygame.number(atoi(input));
	      continue;
	    }
	  else
	    {
	      printf("Unrecognised command. Type `help' for help.\n");
	      continue;
	    }
	}

      if(mygame.running() & flags[i])
	mygame.command(i,arg);
      else
	printf("You cannot execute `%s' right now.\n",input);
    } while (strcmp(input,"quit"));

  return 0;
}




